<?php
/*
Plugin Name: GameBattles Gamer Tags
Plugin URI: http://www.armyofdrunks.com/
Description: Adds your GameBattles XBOX Live Gamertag to your sidebar
Author: Rob McGhee
Version: 1.0.0
Author URI: http://www.llygoden.com/
*/


function widget_xboxgamertag_init() {

	if ( !function_exists('register_sidebar_widget') )
		return;



	function widget_xboxgamertag($args) {

		extract($args);
		$options = get_option('widget_xboxgamertag');
		$title = $options['title'];
		$gb = $options['gamertag'];
		
		echo $before_widget . $before_title . $title . $after_title;
		
		if (($gb == "" )||(gb == "Stats.xml URL")){ // check that info was added
			echo "You must enter a valid GameBattles URL"; // error message for not having details
		}else{
			if(!$feed = file_get_contents($gb)){ // get gamebattles XML
				echo "Unable to open the GameBattles team list at the moment"; // if we can't get the file display an error message
			}else{	
				$feed = uncdata($feed);
				$gbxml = simplexml_load_string($feed); // load into simplexml
							
				foreach ($gbxml->roster->player as $player){ //loop through each player
					$gamertag = $player->name;
					echo '<br><iframe src="http://gamercard.xbox.com/'.$gamertag.'.card" scrolling="no" frameBorder="0" height="140" width="204">'.$gamertag.'</iframe>';		
				}
			}
		}

	}



	function widget_xboxgamertag_control() {



		$options = get_option('widget_xboxgamertag');

		if ( !is_array($options) )

			$options = array('title'=>'Stats.xml URL', 'gamertag'=>'trixie360');

		if ( $_POST['xboxgamertag-submit'] ) {

			$options['title'] = strip_tags(stripslashes($_POST['xboxgamertag-title']));

			$options['gamertag'] = strip_tags(stripslashes($_POST['xboxgamertag-gamertag']));

			update_option('widget_xboxgamertag', $options);

		}

		$title = htmlspecialchars($options['title'], ENT_QUOTES);

		$gamertag = htmlspecialchars($options['gamertag'], ENT_QUOTES);

		echo '<p style="text-align:right;"><label for="xboxgamertag-title">Title: <input style="width: 200px;" id="xboxgamertag-title" name="xboxgamertag-title" type="text" value="'.$title.'" /></label></p>';

		echo '<p style="text-align:right;"><label for="xboxgamertag-gamertag">GameBattles URL: <input style="width: 200px;" id="xboxgamertag-gamertag" name="xboxgamertag-gamertag" type="text" value="'.$gamertag.'" /></label></p>';

		echo '<input type="hidden" id="xboxgamertag-submit" name="xboxgamertag-submit" value="1" />';

	}



	register_sidebar_widget('XBOX Gamertag', 'widget_xboxgamertag');

	register_widget_control('XBOX Gamertag', 'widget_xboxgamertag_control', 300, 100);



}

function uncdata($xml)
    {
        $state = 'out';
        $a = str_split($xml);
        $new_xml = '';

        foreach ($a AS $k => $v) {
            // Deal with "state".
            switch ( $state ) {
                case 'out':
                    if ( '<' == $v ) {
                        $state = $v;
                    } else {
                        $new_xml .= $v;
                    }
                break;

                case '<':
                    if ( '!' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                 case '<!':
                    if ( '[' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![':
                    if ( 'C' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![C':
                    if ( 'D' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![CD':
                    if ( 'A' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![CDA':
                    if ( 'T' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![CDAT':
                    if ( 'A' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![CDATA':
                    if ( '[' == $v  ) {


                        $cdata = '';
                        $state = 'in';
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case 'in':
                    if ( ']' == $v ) {
                        $state = $v;
                    } else {
                        $cdata .= $v;
                    }
                break;

                case ']':
                    if (  ']' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $cdata .= $state . $v;
                        $state = 'in';
                    }
                break;

                case ']]':
                    if (  '>' == $v  ) {
                        $new_xml .= str_replace('>','&gt;',
                                    str_replace('>','&lt;',
                                    str_replace('"','&quot;',
                                    str_replace('&','&amp;',
                                    $cdata))));
                        $state = 'out';
                    } else {
                        $cdata .= $state . $v;
                        $state = 'in';
                    }
                break;
            } // switch
        }
        return $new_xml;
    }
	
add_action('plugins_loaded', 'widget_xboxgamertag_init');



?>